Index: tadata/trunk/toolkit/components/avatech/avatech-detector.xml
===================================================================
--- /metadata/trunk/toolkit/components/avatech/avatech-detector.xml	(revision 231)
+++ 	(revision )
@@ -1,119 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<CMD_ComponentSpec xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-    xsi:noNamespaceSchemaLocation="../../general-component-schema.xsd" isProfile="true">
-    <Header>
-        <ID>avatech.detector</ID>
-        <Name>AVATECH detector</Name>
-        <Description>See: http://avatech.mpi.nl/avatech/</Description>
-    </Header>
-    <CMD_Component name="DETECTOR">
-        
-        <CMD_Element name="detector" ValueScheme="string">
-            <AttributeList>
-                <Attribute >
-                    <Name>runLinux</Name>
-                    <Type>string</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>runMac</Name>
-                    <Type>string</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>runWin</Name>
-                    <Type>string</Type>
-                </Attribute>
-                <Attribute>
-                    <Name>info</Name>
-                    <Type>string</Type>
-                </Attribute>
-            </AttributeList>
-        </CMD_Element>
-        
-        <CMD_Element name="numparam" CardinalityMin="0" CardinalityMax="unbounded" ValueScheme="string">
-            <AttributeList>
-                <Attribute>
-                    <Name>min</Name>
-                    <Type>float</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>max</Name>
-                    <Type>float</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>default</Name>
-                    <Type>float</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>info</Name>
-                    <Type>string</Type>
-                </Attribute>
-            </AttributeList>
-        </CMD_Element>
-        
-        <CMD_Element name="textparam" CardinalityMin="0" CardinalityMax="unbounded" ValueScheme="string">
-            <AttributeList>
-                <Attribute >
-                    <Name>convoc</Name>
-                    <Type>string</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>default</Name>
-                    <Type>string</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>info</Name>
-                    <Type>string</Type>
-                </Attribute>
-            </AttributeList>
-        </CMD_Element>
-        
-        <CMD_Element name="input" CardinalityMax="unbounded" ValueScheme="string">
-            <AttributeList>
-                <Attribute >
-                    <Name>type</Name>
-                    <ValueScheme>
-                        <enumeration>
-                            <item>audio</item>
-                            <item>video</item>
-                            <item>tier</item>
-                            <item>timeseries</item>
-                        </enumeration>
-                    </ValueScheme>
-                </Attribute>
-                <Attribute >
-                    <Name>optional</Name>
-                    <Type>boolean</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>info</Name>
-                    <Type>string</Type>
-                </Attribute>
-            </AttributeList>
-        </CMD_Element>
-    
-        <CMD_Element name="output" CardinalityMax="unbounded" ValueScheme="string">
-            <AttributeList>
-                <Attribute >
-                    <Name>type</Name>
-                    <ValueScheme>
-                        <enumeration>
-                            <item>audio</item>
-                            <item>video</item>
-                            <item>tier</item>
-                            <item>timeseries</item>
-                        </enumeration>
-                        </ValueScheme>
-                </Attribute>
-                <Attribute >
-                    <Name>optional</Name>
-                    <Type>boolean</Type>
-                </Attribute>
-                <Attribute >
-                    <Name>info</Name>
-                    <Type>string</Type>
-                </Attribute>
-            </AttributeList>
-        </CMD_Element>
-    
-    </CMD_Component>
-</CMD_ComponentSpec>
Index: tadata/trunk/toolkit/components/avatech/avatech-detector.xsd
===================================================================
--- /metadata/trunk/toolkit/components/avatech/avatech-detector.xsd	(revision 231)
+++ 	(revision )
@@ -1,187 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:dcr="http://www.isocat.org">
-   <xs:element name="CMD">
-      <xs:complexType>
-         <xs:sequence>
-            <xs:element name="Header">
-               <xs:complexType>
-                  <xs:sequence>
-                     <xs:element name="MdCreator" type="xs:string" minOccurs="0"/>
-                     <xs:element name="MdCreationDate" type="xs:date" minOccurs="0"/>
-                     <xs:element name="MdSelfLink" type="xs:anyURI" minOccurs="0"/>
-                     <xs:element name="MdProfile" type="xs:anyURI" minOccurs="0"/>
-                  </xs:sequence>
-               </xs:complexType>
-            </xs:element>
-            <xs:element name="Resources">
-               <xs:complexType>
-                  <xs:sequence>
-                     <xs:element name="ResourceProxyList">
-                        <xs:complexType>
-                           <xs:sequence>
-                              <xs:element maxOccurs="unbounded" minOccurs="0" name="ResourceProxy">
-                                 <xs:complexType>
-                                    <xs:sequence>
-                                       <xs:element maxOccurs="1" minOccurs="1" name="ResourceType">
-                                          <xs:simpleType>
-                                             <xs:restriction base="xs:string">
-                                                <xs:enumeration value="Metadata">
-                                                   <xs:annotation>
-                                                      <xs:documentation>The ResourceProxy
-                                                  refers to another component
-                                                  metadata instance (e.g. for
-                                                  grouping metadata descriptions
-                                                  into
-                                                  collections)</xs:documentation>
-                                                   </xs:annotation>
-                                                </xs:enumeration>
-                                                <xs:enumeration value="Resource">
-                                                   <xs:annotation>
-                                                      <xs:documentation>The ResourceProxy
-                                                  refers to a file that is not a
-                                                  metadata instance (e.g. a text
-                                                  document)</xs:documentation>
-                                                   </xs:annotation>
-                                                </xs:enumeration>
-                                             </xs:restriction>
-                                          </xs:simpleType>
-                                       </xs:element>
-                                       <xs:element maxOccurs="1" minOccurs="1" name="ResourceRef" type="xs:anyURI"/>
-                                    </xs:sequence>
-                                    <xs:attribute name="id" type="xs:ID" use="required"/>
-                                 </xs:complexType>
-                              </xs:element>
-                           </xs:sequence>
-                        </xs:complexType>
-                     </xs:element>
-                     <xs:element name="JournalFileProxyList">
-                        <xs:complexType>
-                           <xs:sequence>
-                              <xs:element maxOccurs="unbounded" minOccurs="0" name="JournalFileProxy">
-                                 <xs:complexType>
-                                    <xs:sequence>
-                                       <xs:element maxOccurs="1" minOccurs="1" name="JournalFileRef" type="xs:anyURI"/>
-                                    </xs:sequence>
-                                 </xs:complexType>
-                              </xs:element>
-                           </xs:sequence>
-                        </xs:complexType>
-                     </xs:element>
-                     <xs:element name="ResourceRelationList">
-                        <xs:complexType>
-                           <xs:sequence>
-                              <xs:element maxOccurs="unbounded" minOccurs="0" name="ResourceRelation">
-                                 <xs:complexType>
-                                    <xs:sequence>
-                                       <xs:element maxOccurs="1" minOccurs="1" name="RelationType"/>
-                                       <xs:element maxOccurs="1" minOccurs="1" name="Res1">
-                                          <xs:complexType>
-                                             <xs:attribute name="ref" type="xs:IDREF"/>
-                                          </xs:complexType>
-                                       </xs:element>
-                                       <xs:element maxOccurs="1" minOccurs="1" name="Res2">
-                                          <xs:complexType>
-                                             <xs:attribute name="ref" type="xs:IDREF"/>
-                                          </xs:complexType>
-                                       </xs:element>
-                                    </xs:sequence>
-                                 </xs:complexType>
-                              </xs:element>
-                           </xs:sequence>
-                        </xs:complexType>
-                     </xs:element>
-                  </xs:sequence>
-               </xs:complexType>
-            </xs:element>
-            <xs:element name="Components">
-               <xs:complexType>
-                  <xs:sequence>
-                     <xs:element name="DETECTOR">
-                        <xs:complexType>
-                           <xs:sequence>
-                              <xs:element name="detector">
-                                 <xs:complexType>
-                                    <xs:simpleContent>
-                                       <xs:extension base="xs:string">
-                                          <xs:attribute name="runLinux" type="xs:string"/>
-                                          <xs:attribute name="runMac" type="xs:string"/>
-                                          <xs:attribute name="runWin" type="xs:string"/>
-                                          <xs:attribute name="info" type="xs:string"/>
-                                       </xs:extension>
-                                    </xs:simpleContent>
-                                 </xs:complexType>
-                              </xs:element>
-                              <xs:element name="numparam" minOccurs="0" maxOccurs="unbounded">
-                                 <xs:complexType>
-                                    <xs:simpleContent>
-                                       <xs:extension base="xs:string">
-                                          <xs:attribute name="min" type="xs:float"/>
-                                          <xs:attribute name="max" type="xs:float"/>
-                                          <xs:attribute name="default" type="xs:float"/>
-                                          <xs:attribute name="info" type="xs:string"/>
-                                       </xs:extension>
-                                    </xs:simpleContent>
-                                 </xs:complexType>
-                              </xs:element>
-                              <xs:element name="textparam" minOccurs="0" maxOccurs="unbounded">
-                                 <xs:complexType>
-                                    <xs:simpleContent>
-                                       <xs:extension base="xs:string">
-                                          <xs:attribute name="convoc" type="xs:string"/>
-                                          <xs:attribute name="default" type="xs:string"/>
-                                          <xs:attribute name="info" type="xs:string"/>
-                                       </xs:extension>
-                                    </xs:simpleContent>
-                                 </xs:complexType>
-                              </xs:element>
-                              <xs:element name="input" maxOccurs="unbounded">
-                                 <xs:complexType>
-                                    <xs:simpleContent>
-                                       <xs:extension base="xs:string">
-                                          <xs:attribute name="type">
-                                             <xs:simpleType>
-                                                <xs:restriction base="xs:string">
-                                                   <xs:enumeration value="audio"/>
-                                                   <xs:enumeration value="video"/>
-                                                   <xs:enumeration value="tier"/>
-                                                   <xs:enumeration value="timeseries"/>
-                                                </xs:restriction>
-                                             </xs:simpleType>
-                                          </xs:attribute>
-                                          <xs:attribute name="optional" type="xs:boolean"/>
-                                          <xs:attribute name="info" type="xs:string"/>
-                                       </xs:extension>
-                                    </xs:simpleContent>
-                                 </xs:complexType>
-                              </xs:element>
-                              <xs:element name="output" maxOccurs="unbounded">
-                                 <xs:complexType>
-                                    <xs:simpleContent>
-                                       <xs:extension base="xs:string">
-                                          <xs:attribute name="type">
-                                             <xs:simpleType>
-                                                <xs:restriction base="xs:string">
-                                                   <xs:enumeration value="audio"/>
-                                                   <xs:enumeration value="video"/>
-                                                   <xs:enumeration value="tier"/>
-                                                   <xs:enumeration value="timeseries"/>
-                                                </xs:restriction>
-                                             </xs:simpleType>
-                                          </xs:attribute>
-                                          <xs:attribute name="optional" type="xs:boolean"/>
-                                          <xs:attribute name="info" type="xs:string"/>
-                                       </xs:extension>
-                                    </xs:simpleContent>
-                                 </xs:complexType>
-                              </xs:element>
-                           </xs:sequence>
-                           <xs:attribute name="ref" type="xs:IDREF"/>
-                        </xs:complexType>
-                     </xs:element>
-                  </xs:sequence>
-               </xs:complexType>
-            </xs:element>
-         </xs:sequence>
-      </xs:complexType>
-   </xs:element>
-</xs:schema>
Index: /metadata/trunk/toolkit/components/avatech/avatech-recognizer.xml
===================================================================
--- /metadata/trunk/toolkit/components/avatech/avatech-recognizer.xml	(revision 232)
+++ /metadata/trunk/toolkit/components/avatech/avatech-recognizer.xml	(revision 232)
@@ -0,0 +1,144 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<CMD_ComponentSpec xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xsi:noNamespaceSchemaLocation="../../general-component-schema.xsd" isProfile="true">
+    <Header>
+        <ID>avatech.recognizer</ID>
+        <Name>AVATECH recognizer</Name>
+        <Description>See: http://avatech.mpi.nl/avatech/</Description>
+    </Header>
+    <CMD_Component name="RECOGNIZER">
+        
+        <CMD_Element name="recognizer" ValueScheme="string">
+            <AttributeList>
+                <Attribute >
+                    <Name>recognizerType</Name>
+                    <ValueScheme>
+                        <enumeration>
+                            <item>direct</item>
+                            <item>local</item>
+                            <item>shared</item>
+                            <item>remote</item>
+                        </enumeration>
+                    </ValueScheme>
+                </Attribute>
+                <Attribute >
+                    <Name>runLinux</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>runMac</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>runWin</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute>
+                    <Name>info</Name>
+                    <Type>string</Type>
+                </Attribute>
+            </AttributeList>
+        </CMD_Element>
+        
+        <CMD_Element name="numparam" CardinalityMin="0" CardinalityMax="unbounded" ValueScheme="string">
+            <AttributeList>
+                <Attribute>
+                    <Name>min</Name>
+                    <Type>float</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>max</Name>
+                    <Type>float</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>default</Name>
+                    <Type>float</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>info</Name>
+                    <Type>string</Type>
+                </Attribute>
+            </AttributeList>
+        </CMD_Element>
+        
+        <CMD_Element name="textparam" CardinalityMin="0" CardinalityMax="unbounded" ValueScheme="string">
+            <AttributeList>
+                <Attribute >
+                    <Name>convoc</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>default</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>info</Name>
+                    <Type>string</Type>
+                </Attribute>
+            </AttributeList>
+        </CMD_Element>
+        
+        <CMD_Element name="input" CardinalityMax="unbounded" ValueScheme="string">
+            <AttributeList>
+                <Attribute >
+                    <Name>type</Name>
+                    <ValueScheme>
+                        <enumeration>
+                            <item>audio</item>
+                            <item>video</item>
+                            <item>tier</item>
+                            <item>csvtier</item>
+                            <item>timeseries</item>
+                            <item>csvtimeseries</item>
+                            <item>auxiliary</item>
+                        </enumeration>
+                    </ValueScheme>
+                </Attribute>
+                <Attribute >
+                    <Name>mimetypes</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>optional</Name>
+                    <Type>boolean</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>info</Name>
+                    <Type>string</Type>
+                </Attribute>
+            </AttributeList>
+        </CMD_Element>
+    
+        <CMD_Element name="output" CardinalityMax="unbounded" ValueScheme="string">
+            <AttributeList>
+                <Attribute >
+                    <Name>type</Name>
+                    <ValueScheme>
+                        <enumeration>
+                            <item>audio</item>
+                            <item>video</item>
+                            <item>tier</item>
+                            <item>csvtier</item>
+                            <item>timeseries</item>
+                            <item>csvtimeseries</item>
+                            <item>auxiliary</item>
+                        </enumeration>
+                        </ValueScheme>
+                </Attribute>
+                <Attribute >
+                    <Name>mimetypes</Name>
+                    <Type>string</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>optional</Name>
+                    <Type>boolean</Type>
+                </Attribute>
+                <Attribute >
+                    <Name>info</Name>
+                    <Type>string</Type>
+                </Attribute>
+            </AttributeList>
+        </CMD_Element>
+    
+    </CMD_Component>
+</CMD_ComponentSpec>
Index: /metadata/trunk/toolkit/components/avatech/avatech-recognizer.xsd
===================================================================
--- /metadata/trunk/toolkit/components/avatech/avatech-recognizer.xsd	(revision 232)
+++ /metadata/trunk/toolkit/components/avatech/avatech-recognizer.xsd	(revision 232)
@@ -0,0 +1,205 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:dcr="http://www.isocat.org">
+   <xs:element name="CMD">
+      <xs:complexType>
+         <xs:sequence>
+            <xs:element name="Header">
+               <xs:complexType>
+                  <xs:sequence>
+                     <xs:element name="MdCreator" type="xs:string" minOccurs="0"/>
+                     <xs:element name="MdCreationDate" type="xs:date" minOccurs="0"/>
+                     <xs:element name="MdSelfLink" type="xs:anyURI" minOccurs="0"/>
+                     <xs:element name="MdProfile" type="xs:anyURI" minOccurs="0"/>
+                  </xs:sequence>
+               </xs:complexType>
+            </xs:element>
+            <xs:element name="Resources">
+               <xs:complexType>
+                  <xs:sequence>
+                     <xs:element name="ResourceProxyList">
+                        <xs:complexType>
+                           <xs:sequence>
+                              <xs:element maxOccurs="unbounded" minOccurs="0" name="ResourceProxy">
+                                 <xs:complexType>
+                                    <xs:sequence>
+                                       <xs:element maxOccurs="1" minOccurs="1" name="ResourceType">
+                                          <xs:simpleType>
+                                             <xs:restriction base="xs:string">
+                                                <xs:enumeration value="Metadata">
+                                                   <xs:annotation>
+                                                      <xs:documentation>The ResourceProxy
+                                                  refers to another component
+                                                  metadata instance (e.g. for
+                                                  grouping metadata descriptions
+                                                  into
+                                                  collections)</xs:documentation>
+                                                   </xs:annotation>
+                                                </xs:enumeration>
+                                                <xs:enumeration value="Resource">
+                                                   <xs:annotation>
+                                                      <xs:documentation>The ResourceProxy
+                                                  refers to a file that is not a
+                                                  metadata instance (e.g. a text
+                                                  document)</xs:documentation>
+                                                   </xs:annotation>
+                                                </xs:enumeration>
+                                             </xs:restriction>
+                                          </xs:simpleType>
+                                       </xs:element>
+                                       <xs:element maxOccurs="1" minOccurs="1" name="ResourceRef" type="xs:anyURI"/>
+                                    </xs:sequence>
+                                    <xs:attribute name="id" type="xs:ID" use="required"/>
+                                 </xs:complexType>
+                              </xs:element>
+                           </xs:sequence>
+                        </xs:complexType>
+                     </xs:element>
+                     <xs:element name="JournalFileProxyList">
+                        <xs:complexType>
+                           <xs:sequence>
+                              <xs:element maxOccurs="unbounded" minOccurs="0" name="JournalFileProxy">
+                                 <xs:complexType>
+                                    <xs:sequence>
+                                       <xs:element maxOccurs="1" minOccurs="1" name="JournalFileRef" type="xs:anyURI"/>
+                                    </xs:sequence>
+                                 </xs:complexType>
+                              </xs:element>
+                           </xs:sequence>
+                        </xs:complexType>
+                     </xs:element>
+                     <xs:element name="ResourceRelationList">
+                        <xs:complexType>
+                           <xs:sequence>
+                              <xs:element maxOccurs="unbounded" minOccurs="0" name="ResourceRelation">
+                                 <xs:complexType>
+                                    <xs:sequence>
+                                       <xs:element maxOccurs="1" minOccurs="1" name="RelationType"/>
+                                       <xs:element maxOccurs="1" minOccurs="1" name="Res1">
+                                          <xs:complexType>
+                                             <xs:attribute name="ref" type="xs:IDREF"/>
+                                          </xs:complexType>
+                                       </xs:element>
+                                       <xs:element maxOccurs="1" minOccurs="1" name="Res2">
+                                          <xs:complexType>
+                                             <xs:attribute name="ref" type="xs:IDREF"/>
+                                          </xs:complexType>
+                                       </xs:element>
+                                    </xs:sequence>
+                                 </xs:complexType>
+                              </xs:element>
+                           </xs:sequence>
+                        </xs:complexType>
+                     </xs:element>
+                  </xs:sequence>
+               </xs:complexType>
+            </xs:element>
+            <xs:element name="Components">
+               <xs:complexType>
+                  <xs:sequence>
+                     <xs:element name="RECOGNIZER">
+                        <xs:complexType>
+                           <xs:sequence>
+                              <xs:element name="recognizer">
+                                 <xs:complexType>
+                                    <xs:simpleContent>
+                                       <xs:extension base="xs:string">
+                                          <xs:attribute name="recognizerType">
+                                             <xs:simpleType>
+                                                <xs:restriction base="xs:string">
+                                                   <xs:enumeration value="direct"/>
+                                                   <xs:enumeration value="local"/>
+                                                   <xs:enumeration value="shared"/>
+                                                   <xs:enumeration value="remote"/>
+                                                </xs:restriction>
+                                             </xs:simpleType>
+                                          </xs:attribute>
+                                          <xs:attribute name="runLinux" type="xs:string"/>
+                                          <xs:attribute name="runMac" type="xs:string"/>
+                                          <xs:attribute name="runWin" type="xs:string"/>
+                                          <xs:attribute name="info" type="xs:string"/>
+                                       </xs:extension>
+                                    </xs:simpleContent>
+                                 </xs:complexType>
+                              </xs:element>
+                              <xs:element name="numparam" minOccurs="0" maxOccurs="unbounded">
+                                 <xs:complexType>
+                                    <xs:simpleContent>
+                                       <xs:extension base="xs:string">
+                                          <xs:attribute name="min" type="xs:float"/>
+                                          <xs:attribute name="max" type="xs:float"/>
+                                          <xs:attribute name="default" type="xs:float"/>
+                                          <xs:attribute name="info" type="xs:string"/>
+                                       </xs:extension>
+                                    </xs:simpleContent>
+                                 </xs:complexType>
+                              </xs:element>
+                              <xs:element name="textparam" minOccurs="0" maxOccurs="unbounded">
+                                 <xs:complexType>
+                                    <xs:simpleContent>
+                                       <xs:extension base="xs:string">
+                                          <xs:attribute name="convoc" type="xs:string"/>
+                                          <xs:attribute name="default" type="xs:string"/>
+                                          <xs:attribute name="info" type="xs:string"/>
+                                       </xs:extension>
+                                    </xs:simpleContent>
+                                 </xs:complexType>
+                              </xs:element>
+                              <xs:element name="input" maxOccurs="unbounded">
+                                 <xs:complexType>
+                                    <xs:simpleContent>
+                                       <xs:extension base="xs:string">
+                                          <xs:attribute name="type">
+                                             <xs:simpleType>
+                                                <xs:restriction base="xs:string">
+                                                   <xs:enumeration value="audio"/>
+                                                   <xs:enumeration value="video"/>
+                                                   <xs:enumeration value="tier"/>
+                                                   <xs:enumeration value="csvtier"/>
+                                                   <xs:enumeration value="timeseries"/>
+                                                   <xs:enumeration value="csvtimeseries"/>
+                                                   <xs:enumeration value="auxiliary"/>
+                                                </xs:restriction>
+                                             </xs:simpleType>
+                                          </xs:attribute>
+                                          <xs:attribute name="mimetypes" type="xs:string"/>
+                                          <xs:attribute name="optional" type="xs:boolean"/>
+                                          <xs:attribute name="info" type="xs:string"/>
+                                       </xs:extension>
+                                    </xs:simpleContent>
+                                 </xs:complexType>
+                              </xs:element>
+                              <xs:element name="output" maxOccurs="unbounded">
+                                 <xs:complexType>
+                                    <xs:simpleContent>
+                                       <xs:extension base="xs:string">
+                                          <xs:attribute name="type">
+                                             <xs:simpleType>
+                                                <xs:restriction base="xs:string">
+                                                   <xs:enumeration value="audio"/>
+                                                   <xs:enumeration value="video"/>
+                                                   <xs:enumeration value="tier"/>
+                                                   <xs:enumeration value="csvtier"/>
+                                                   <xs:enumeration value="timeseries"/>
+                                                   <xs:enumeration value="csvtimeseries"/>
+                                                   <xs:enumeration value="auxiliary"/>
+                                                </xs:restriction>
+                                             </xs:simpleType>
+                                          </xs:attribute>
+                                          <xs:attribute name="mimetypes" type="xs:string"/>
+                                          <xs:attribute name="optional" type="xs:boolean"/>
+                                          <xs:attribute name="info" type="xs:string"/>
+                                       </xs:extension>
+                                    </xs:simpleContent>
+                                 </xs:complexType>
+                              </xs:element>
+                           </xs:sequence>
+                           <xs:attribute name="ref" type="xs:IDREF"/>
+                        </xs:complexType>
+                     </xs:element>
+                  </xs:sequence>
+               </xs:complexType>
+            </xs:element>
+         </xs:sequence>
+      </xs:complexType>
+   </xs:element>
+</xs:schema>
Index: tadata/trunk/toolkit/components/avatech/detectormetadata-example-instance.xml
===================================================================
--- /metadata/trunk/toolkit/components/avatech/detectormetadata-example-instance.xml	(revision 231)
+++ 	(revision )
@@ -1,45 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<CMD xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-    xsi:noNamespaceSchemaLocation="file:/home/dietuyt/svn/clarin/metadata/trunk/toolkit/components/avatech/avatech-detector.xsd">
-    <Header></Header>
-    <Resources>
-        <ResourceProxyList></ResourceProxyList>
-        <JournalFileProxyList></JournalFileProxyList>
-        <ResourceRelationList></ResourceRelationList>
-    </Resources>
-    <Components>
-        <DETECTOR>
-            <detector runLinux="PitchPraat.sh" runMac="PitchPraat.sh" runWin="PP.bat"
-                info="Tag vowels (volume peaks of voiced timespans)">TagVowels</detector>
-            <numparam min="150" max="1500" default="550"
-                info="Pitch ceiling [Hz], eg. 300 male / 550 female">max_f0</numparam>
-            <numparam min="0.5" max="5.0" default="2.0"
-                info="Intensity change [dB] to start/end a peak">epsilon</numparam>
-            <numparam min="0.01" max="0.3" default="0.03"
-                info="Minimum amplitude (0..1) for pitch analysis">vol_threshold</numparam>
-            <numparam min="0.2" max="0.8" default="0.45"
-                info="Minimum voicing of voiced timespans">voicedness_threshold</numparam>
-            <!-- NOTE: If convoc is empty, any text can be entered -->
-            <textparam convoc="true false" default="false"
-                info="Set to true to get debug output">debug</textparam>
-            <!-- NOTE: Type could also be one of: video / tier / timeseries -->
-            <!-- NOTE: Input is passed as filename (tier/timeseries: CSV files) -->
-            <input type="audio" optional="false"
-                info="Mono or stereo WAV to scan">source</input>
-            <!-- NOTE: A detector could use this to override own analysis -->
-            <input type="timeseries" optional="true"
-                info="Pre-made time, pitch[Hz], volume[dB] CSV">pitch_in</input>
-            <!-- NOTE: timeseries format: CSV with msec time, data[, data...] -->
-            <!-- NOTE: Making output items optional can save time or space -->
-            <output type="timeseries" optional="true"
-                info="Pitch (or undefined) and volume, 100 samples/s">pitch_out</output>
-            <!-- NOTE: Can we bundle tiers in one output file? -->
-            <output type="tier" optional="false"
-                info="Vowel segments and their average f0 [Hz]">vowel_f0</output>
-            <output type="tier" optional="false"
-                info="Vowel segments and their average intensity [db]">vowel_db</output>
-            <!-- ... several other tiers omitted for this example ... -->
-            <!-- NOTE: tier format: CSV with msec start, end, content -->
-        </DETECTOR>
-    </Components>
-</CMD>
Index: /metadata/trunk/toolkit/components/avatech/recognizer.cmdi
===================================================================
--- /metadata/trunk/toolkit/components/avatech/recognizer.cmdi	(revision 232)
+++ /metadata/trunk/toolkit/components/avatech/recognizer.cmdi	(revision 232)
@@ -0,0 +1,41 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<CMD xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xsi:noNamespaceSchemaLocation="file:avatech-recognizer.xsd">
+    <Header></Header>
+    <Resources>
+        <ResourceProxyList></ResourceProxyList>
+        <JournalFileProxyList></JournalFileProxyList>
+        <ResourceRelationList></ResourceRelationList>
+    </Resources>
+    <Components>
+        <RECOGNIZER>
+            <recognizer recognizerType="local" runLinux="java PitchComponent" runMac="java PitchComponent" runWin="java PitchComponent"
+                info="Tag vowels (volume peaks of voiced timespans)">TagVowels</recognizer>
+            <numparam min="150" max="1500" default="550"
+                info="Pitch ceiling [Hz], eg. 300 male / 550 female">max_f0</numparam>
+            <numparam min="0.5" max="5.0" default="2.0"
+                info="Intensity change [dB] to start/end a peak">epsilon</numparam>
+            <numparam min="0.01" max="0.3" default="0.03"
+                info="Minimum amplitude (0..1) for pitch analysis">silence_threshold</numparam>
+            <numparam min="0.2" max="0.8" default="0.45"
+                info="Minimum voicing of voiced timespans">voicing_threshold</numparam>
+            <!-- NOTE: If convoc is empty, any text can be entered -->
+            <textparam convoc="normal verbose debug" default="normal"
+                info="Adjust amount of messages during calculation here">loglevel</textparam>
+            <input type="audio" optional="false" mimetypes="audio/x-wav"
+                info="Mono or stereo WAV to scan">source</input>
+            <input type="csvtimeseries" optional="true" mimetypes="text/csv"
+                info="Pre-made time, pitch[Hz], volume[dB] CSV">precalc_f0_db</input>
+            <output type="csvtimeseries" optional="true" mimetypes="text/csv"
+                info="Pitch (or undefined) and volume, 100 samples/s">output_f0_db</output>
+            <output type="csvtier" optional="false" mimetypes="text/csv"
+                info="Vowel segments and their average f0 [Hz] and volume [dB]">vowel_f0_db</output>
+            <output type="csvtier" optional="true" mimetypes="text/csv"
+                info="Vowel segments and their min, max, initial and final f0 [Hz]">vowel_stats</output>
+            <output type="tier" optional="true" mimetypes="text/xml"
+                info="Vowel segments and their average f0 [Hz] and volume [dB]">vowel_f0_db_xml</output>
+            <output type="tier" optional="true" mimetypes="text/xml"
+                info="Vowel segments and their min, max, initial and final f0 [Hz]">vowel_stats_xml</output>
+        </RECOGNIZER>
+    </Components>
+</CMD>