Index: /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/common/components/HighlightSelectionItemRenderer.as
===================================================================
--- /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/common/components/HighlightSelectionItemRenderer.as	(revision 287)
+++ /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/common/components/HighlightSelectionItemRenderer.as	(revision 288)
@@ -1,6 +1,6 @@
 package clarin.cmdi.componentregistry.common.components {
-	import mx.controls.dataGridClasses.DataGridItemRenderer;
+	import mx.controls.Label;
 
-	public class HighlightSelectionItemRenderer extends OptionalTooltipDataGridItemRenderer {
+	public class HighlightSelectionItemRenderer extends Label {
 
 		private static const OPEN_TAG:String = "<b>";
Index: mponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/common/components/OptionalTooltipDataGridItemRenderer.as
===================================================================
--- /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/common/components/OptionalTooltipDataGridItemRenderer.as	(revision 287)
+++ 	(revision )
@@ -1,15 +1,0 @@
-package clarin.cmdi.componentregistry.common.components {
-	import mx.controls.dataGridClasses.DataGridItemRenderer;
-
-	public class OptionalTooltipDataGridItemRenderer extends DataGridItemRenderer {
-		public function OptionalTooltipDataGridItemRenderer() {
-			super();
-		}
-
-        public override function set toolTip(value:String):void {
-            if (textWidth > width) {
-                super.toolTip = value;
-            }
-        }
-	}
-}
Index: /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/editor/ComponentEdit.as
===================================================================
--- /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/editor/ComponentEdit.as	(revision 287)
+++ /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/editor/ComponentEdit.as	(revision 288)
@@ -99,4 +99,5 @@
 			var componentLink:FormItem = createComponentLink(_component);
 			if (componentLink != null) {
+			    addCardinalityInput();
 				addChild(componentLink);
 			} else {
@@ -107,14 +108,18 @@
 						_component.conceptLink = val;
 					}));
-				addChild(new FormItemInputLine("CardinalityMin", _component.cardinalityMin, function(val:String):void {
-						_component.cardinalityMin = val;
-					}));
-				addChild(new FormItemInputLine("CardinalityMax", _component.cardinalityMax, function(val:String):void {
-						_component.cardinalityMax = val;
-					}));
+			    addCardinalityInput();
 				handleCMDAttributeList();
 				handleElements(_component.cmdElements);
 				handleComponents(_component.cmdComponents); //recursion
 			}
+		}
+		
+		private function addCardinalityInput():void {
+				addChild(new FormItemInputLine("CardinalityMin", _component.cardinalityMin, function(val:String):void {
+						_component.cardinalityMin = val;
+					}));
+				addChild(new FormItemInputLine("CardinalityMax", _component.cardinalityMax, function(val:String):void {
+						_component.cardinalityMax = val;
+					}));
 		}
 
Index: /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/editor/IsocatSearchPopUp.mxml
===================================================================
--- /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/editor/IsocatSearchPopUp.mxml	(revision 287)
+++ /ComponentRegistry/trunk/ComponentBrowserGui/src/main/flex/clarin/cmdi/componentregistry/editor/IsocatSearchPopUp.mxml	(revision 288)
@@ -52,5 +52,5 @@
 					 dataProvider="{searchService.searchResults}"
 					 resizableColumns="true"
-					 itemRenderer="clarin.cmdi.componentregistry.common.components.OptionalTooltipDataGridItemRenderer"
+					 itemRenderer="mx.controls.Label"
 					 showDataTips="true">
 			<mx:columns>