Index: /metadata/trunk/toolkit/components/clarin-nl/session-text/cmdi-writtenresource.xml
===================================================================
--- /metadata/trunk/toolkit/components/clarin-nl/session-text/cmdi-writtenresource.xml	(revision 304)
+++ /metadata/trunk/toolkit/components/clarin-nl/session-text/cmdi-writtenresource.xml	(revision 305)
@@ -1,8 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<CMD_ComponentSpec xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" isProfile="false"
-                   xsi:schemaLocation="http://www.clarin.eu/cmd http://www.clarin.eu/cmd/general-component-schema.xsd">
+
+<CMD_ComponentSpec xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+    xsi:noNamespaceSchemaLocation="http://www.clarin.eu/cmd/general-component-schema.xsd" isProfile="false">
     
     <Header>
-        <Name/>
+        <Name></Name>
         <Description>Component contains information about a text itself and the dependent resources (e.g. annotations, analyses,... of the text) or about the written resources associated with a mediafile</Description>
     </Header>
@@ -10,10 +11,6 @@
     <CMD_Component name="WrittenResource">
 
-        <CMD_Element name="CreationYear" ValueScheme="gYear"
-                   ConceptLink="http://www.isocat.org/datcat/DC-2510"
-                   CardinalityMin="0"
-                   CardinalityMax="1"/>
-        <CMD_Element name="Derivation" ConceptLink="http://www.isocat.org/datcat/DC-2518"
-                   CardinalityMax="1">
+        <CMD_Element name="CreationYear" ValueScheme="gYear" ConceptLink="http://www.isocat.org/datcat/DC-2510" CardinalityMin="0" CardinalityMax="1"/>
+        <CMD_Element name="Derivation" ConceptLink="http://www.isocat.org/datcat/DC-2518" CardinalityMax="1">
             <ValueScheme>
                 <enumeration>
@@ -29,6 +26,5 @@
             </ValueScheme>
         </CMD_Element>
-        <CMD_Element name="DerivationMode" ConceptLink="http://www.isocat.org/datcat/DC-2516"
-                   CardinalityMax="1">
+        <CMD_Element name="DerivationMode" ConceptLink="http://www.isocat.org/datcat/DC-2516" CardinalityMax="1">
             <ValueScheme>
                 <enumeration>
@@ -43,6 +39,5 @@
         </CMD_Element>
 
-        <CMD_Element name="AnnotationStyle" ConceptLink="http://www.isocat.org/datcat/DC-2325"
-                   CardinalityMax="1">
+        <CMD_Element name="AnnotationStyle" ConceptLink="http://www.isocat.org/datcat/DC-2325" CardinalityMax="1">
             <ValueScheme>
                 <enumeration>
@@ -57,11 +52,7 @@
         </CMD_Element>
         
-        <CMD_Element name="CharacterEncoding" ValueScheme="string"
-                   ConceptLink="http://www.isocat.org/datcat/DC-2564"
-                   CardinalityMin="0"
-                   CardinalityMax="1"/>
+        <CMD_Element name="CharacterEncoding" ValueScheme="string" ConceptLink="http://www.isocat.org/datcat/DC-2564" CardinalityMin="0" CardinalityMax="1"/>
 
-        <CMD_Element name="Anonymized" ConceptLink="http://www.isocat.org/datcat/DC-2548"
-                   CardinalityMax="1">
+        <CMD_Element name="Anonymized" ConceptLink="http://www.isocat.org/datcat/DC-2548" CardinalityMax="1">
             <ValueScheme>
                 <enumeration>
@@ -73,24 +64,12 @@
             </ValueScheme>        
         </CMD_Element>
-        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/common/cmdi-annotationtype.xml"
-                     CardinalityMax="unbounded"
-                     CardinalityMin="1"/>
-        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin/cmdi-annotationformat.xml"
-                     CardinalityMax="1"/>
+        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/common/cmdi-annotationtype.xml" CardinalityMax="unbounded" CardinalityMin="1" />
+        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin/cmdi-annotationformat.xml" CardinalityMax="1" ></CMD_Component>
         <!-- within the component WrittenResource the component TotalSize contains information about the size of the text and/or annotation files-->
-        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/common/cmdi-totalsize.xml"
-                     CardinalityMin="0"
-                     CardinalityMax="1"/>
+        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/common/cmdi-totalsize.xml" CardinalityMin="0" CardinalityMax="1"></CMD_Component>
         <!-- within the component WrittenResource the component Language identifies the language used in the written resource -->
-        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin/cmdi-language.xml"
-                     CardinalityMax="1"/>    
-        <!-- within the component WrittenResource the component Validation contains information about the validation mode, style and level of the written resource-->
-        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/session-text/cmdi-validation.xml"
-                     CardinalityMin="0"
-                     CardinalityMax="1"/>
+        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin/cmdi-language.xml" CardinalityMax="1"></CMD_Component>    
         <!-- within the component WrittenResource the component Description provides the possibility to add extra information about the written resource -->
-        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/common/cmdi-description.xml"
-                     CardinalityMin="0"
-                     CardinalityMax="1"/>
+        <CMD_Component filename="http://www.clarin.eu/cmd/components/clarin-nl/common/cmdi-description.xml" CardinalityMin="0" CardinalityMax="1" />
     </CMD_Component>
 